/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
 Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections;using System.Collections.Generic;using PluginIdea.ContexMenuSystem;namespace PluginIdea.ContexMenuSystem{    public struct CommandType    {        public const int CommonMenu = 0;        public const int UsualAtom = 1;    }    public class CommandConsts    {                public const string OpenScene = "OpenScene";        public const string SaveScene = "SaveScene";        public const string FullScreen = "FullScreen/Window";        public const string RunBackground = "RunBackground";        public const string EditMode = "EditMode";        public const string GameMode = "GameMode";        public const string OpenLogPanel = "OpenLogPanel";        public const string OpenLogErrorPanel = "OpenLogErrorPanel";                public const string Copy = "Copy";        public const string Paste = "Paste";        public const string Delete = "Delete";                public const string ToTop = "ToTop";    }    public class CommandClass     {        private ContextMenu rootMObj;        private GameObject prefab;        private Transform canvasTrans;        private List<ContextMenu> contextMenus = new List<ContextMenu>();        public CommandClass(GameObject contexPrefab, Transform canvasTrans)        {            this.prefab = contexPrefab;            this.canvasTrans = canvasTrans;        }        public void CreateMenuTree(CheckInfo checkInfo)        {                        if (contextMenus.Count > 0)            {                for (int i = 0; i < contextMenus.Count; i++)                {                    GameObject.Destroy(contextMenus[i].gameObject);                }            }            contextMenus.Clear();                                    if (checkInfo.code == CommandType.CommonMenu)            {                var editMObj = GetMenuBlock(new List<CallbackData>() {                        new CallbackData(){                              text = CommandConsts.EditMode,                               opt = new SwitchEditModeOpt(checkInfo)                        },                         new CallbackData(){                              text = CommandConsts.GameMode,                               opt = new SwitchGameModeOpt(checkInfo)                        },                    });                                var gameMObj = GetMenuBlock(new List<CallbackData>() {                        new CallbackData(){                              text = CommandConsts.OpenScene,                               opt = new OpenSceneOpt(checkInfo)                        },                         new CallbackData(){                              text = CommandConsts.SaveScene,                               opt = new SaveSceneOpt(checkInfo)                        },                        new CallbackData(){                              text = CommandConsts.OpenScene,                               opt = new OpenSceneOpt(checkInfo)                        },                         new CallbackData(){                              text = CommandConsts.FullScreen,                               opt = new FullSceenOpt(checkInfo)                        },                          new CallbackData(){                              text = CommandConsts.RunBackground,                               opt = new FullSceenOpt(checkInfo)                        },                           new CallbackData(){                              text = CommandConsts.OpenLogPanel,                               opt = new OpenLogOpt(checkInfo)                        },                            new CallbackData(){                              text = CommandConsts.OpenLogErrorPanel,                               opt = new OpenLogErrorOpt(checkInfo)                        },                    });                                rootMObj = GetMenuBlock(new List<CallbackData>() {                        new CallbackData(){                              text = "Game",                               subContex = gameMObj,                        },                         new CallbackData(){                              text = "Edit",                               subContex = editMObj,                        },                    });            }                        else if (checkInfo.code == CommandType.UsualAtom)            {                                rootMObj = GetMenuBlock(new List<CallbackData>() {                        new CallbackData(){                              text = CommandConsts.Copy,                               opt = new AtomCopyOpt(checkInfo)                        },                         new CallbackData(){                              text = CommandConsts.Paste,                                opt = new AtomPasteOpt(checkInfo)                        },                          new CallbackData(){                              text = CommandConsts.Delete,                                opt = new AtomDeleteOpt(checkInfo)                        },                    });            }        }        public void ShowAtMousePosition()        {            if (rootMObj != null)            {                rootMObj.ShowAtMousePosition();            }        }        private ContextMenu GetMenuBlock(List<CallbackData> callbacks)        {            var alternativeMenu = GameObject.Instantiate<GameObject>(prefab).GetComponent<ContextMenu>();            alternativeMenu.transform.SetParent(this.canvasTrans, false);            alternativeMenu.transform.localScale = Vector3.one;            alternativeMenu.transform.localPosition = Vector3.zero;            callbacks.ForEach(cd => {                var opt = cd.opt;                ContextMenuItem.StandardDelegate processFunc = null;                if (opt != null)                {                    processFunc = opt.Proccess;                }                if (cd.subContex == null)                {                    alternativeMenu.AddMenuItem(cd.text, processFunc);                }                else                {                    alternativeMenu.AddMenuItem(cd.text, processFunc, cd.subContex);                }            });            alternativeMenu.FinaliseMenu();            contextMenus.Add(alternativeMenu);            return alternativeMenu;        }    }}